= How do I use Xvfb to test my web application on a browser? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

When executing web application tests locally, they can run in any number of browsers. SecureCI™ came pre-loaded with <% if ::File.directory?("#{node['browser']['firefox']['install']}") %>Firefox<% end %><% if ::File.directory?("#{node['browser']['chrome']['install']}") %> and Chrome<% end %>.
When these browsers launch locally, they use the local display, but SecureCI™ runs in headless mode, with no X11 display.
This means that in order to run our tests properly in a browser, we need to port over the display to a virtual one.
With [../../AboutSecureCI/Browser#Xvfb Xvfb] installed, we can use it to implement the X11 display server protocol.

To setup our virtual display, you can run the below commands.

{{{
Xvfb :99 -ac 2>/dev/null 1>&2 &
export DISPLAY=:99
}}}

If you want these tests to be kicked off via Jenkins, you can add these commands into a shell build setup.
Your job might look something like below

{{{
#!/bin/sh

Xvfb :99 -ac 2>/dev/null 1>&2 &
export DISPLAY=:99

ant clean
ant build
ant tests
}}}
<%= node['trac']['wiki']['footer'] %>